<?php

// JF + Xolub + Kobis

// Gnration KML des  VOILIERS en 3D
// --------------------
function GetNomVoile($voile){
// retourne un modele de voile
	switch ($voile){
		case '2' :
		case '32' :
		case '64' :
			$nom_voile='spi';
			break;
		case '1' : 
		case '4' : 
		case '8' : 
			$nom_voile='genois';
			break;
		default :
			$nom_voile='codezero';
			break;
	}
	return $nom_voile;
}

// --------------------
function GetFichierModele($nom_voile){
// retourne un modele de fichier dae correspondant a la voile portee
	if ($nom_voile=='spi'){
		 return 'RKN_SPI.dae';
	}
	else if ($nom_voile=='genois'){
		 return 'RKN_GENOIS.dae';
	}
	else {
		return 'RKN_CZ.dae';
	}
}

// --------------------
function GenereCoqueBateau_3D($dossier_3d, $url_serveur, $couleur){
global $dir_serveur;
global $dossier_textures;
	$chemin=$dir_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	if ($url_serveur!=''){ // liens absolus
		$url=$url_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	}
	else{ // liens relatifs
		$url='../'.$dossier_textures;
	}
	
	if ($couleur){
		list($rouge, $vert, $bleu) = explode(';', $couleur);
		$texture=genere_texture($chemin, $rouge, $vert, $bleu);
		if ($texture!=""){
			$s='	<Alias>
		<sourceHref>c.PNG</sourceHref>
    	<targetHref>'.$url.'/'.$texture.'</targetHref>
	</Alias>
';
			return $s;
		}
	}
	return '';
}

// --------------------
function GenereGrandVoileBateau_3D($dossier_3d, $url_serveur, $couleur){
global $dir_serveur;
global $dossier_textures;
	$chemin=$dir_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	if ($url_serveur!=''){ // liens absolus
		$url=$url_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	}
	else{ // liens relatifs
		$url='../'.$dossier_textures;
	}
	
	if ($couleur){
		list($rouge, $vert, $bleu) = explode(';', $couleur);
		// DEBUG
		// echo '<br>Couleur ('.$rouge.', '.$vert.', '.$bleu.')'."\n";
		$texture=genere_texture($chemin, $rouge, $vert, $bleu);

		if ($texture!=""){
			$s='	<Alias>
		<sourceHref>gv.PNG</sourceHref>
    	<targetHref>'.$url.'/'.$texture.'</targetHref>
	</Alias>
';
			return $s;
		}

	}
	return '';
}

// --------------------
function GenereVoileAvantBateau_3D($dossier_3d, $url_serveur, $voile, $couleur){
global $dir_serveur;
global $dossier_textures;
	$chemin=$dir_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	if ($url_serveur!=''){ // liens absolus
		$url=$url_serveur.'/'.$dossier_3d.'/'.$dossier_textures;
	}
	else{ // liens relatifs
		$url='../'.$dossier_textures;
	}
	
	if ($couleur){
		list($rouge, $vert, $bleu) = explode(';', $couleur);
		// DEBUG
		// echo '<br>Couleur ('.$rouge.', '.$vert.', '.$bleu.')'."\n";
		$texture=genere_texture($chemin, $rouge, $vert, $bleu);

		if ($texture!=""){
			$s='	<Alias>
		<sourceHref>vav.PNG</sourceHref>
    	<targetHref>'.$url.'/'.$texture.'</targetHref>
	</Alias>
';
			return $s;
		}
	}
	return '';
}

// --------------------
function GenereRessourceMapBateau_3D($dossier_3d, $url_serveur,$bato){
// 
	$s='<ResourceMap>
';
	$s.=GenereCoqueBateau_3D($dossier_3d, $url_serveur, $bato->couleur_coque);
	$s.=GenereGrandVoileBateau_3D($dossier_3d, $url_serveur, $bato->couleur_gv);
	if (GetNomVoile($bato->voile)=='spi')
		$s.=GenereVoileAvantBateau_3D($dossier_3d, $url_serveur, $bato->voile, $bato->couleur_spi);
	else
		$s.=GenereVoileAvantBateau_3D($dossier_3d, $url_serveur, $bato->voile, $bato->couleur_vav);
	$s.='</ResourceMap>
';
	return $s;
}

// --------------------
function GenereBateauKML_3D($dossier_3d, $url_serveur, $bato, $echelle=6, $altitude=1000){
// Modele 3D

global $groupe;
global $t_groupe;
global $dossier_modeles;
global $afficher_trajectoire;
global $t_parcours;

	// $echelle_z=$echelle*1.5;
	$echelle_z=$echelle;
	$s='';
	if ($url_serveur!=''){ // liens absolus
		$url_modeles=$url_serveur.'/'.$dossier_3d.'/'.$dossier_modeles;
	}
	else{ // liens relatifs
		$url_modeles=$dossier_modeles;
	}
	
	if (!empty($bato)){
		if (!empty($bato->symbole) ){
		// On place juste une balise
		// Pas de parcours
$s.='<Placemark>
<open>1</open>
<description>
<![CDATA[<p>
';
if (!empty($bato->mmsi)){
    $s.=' MMSI: '.$bato->mmsi;
}
else if (!empty($bato->idsol)){
    $s.=' IdSol: '.$bato->idsol;
}
$s.='<br>'.$bato->date_enregistrement.'
<br>Lon: '.$bato->longitude.'
<br>Lat: '.$bato->latitude.'
<br>COG: '.$bato->cog;
if (!empty($bato->sog)){
    $s.='<br>SOG: '.$bato->sog;
}
if (!empty($bato->classement)){
	$s.='<br>Rank : '.$bato->classement;
}
if (!empty($bato->dtg)){
	$s.='<br>DTG : '.$bato->dtg;
}
if (!empty($bato->dbl)){
	$s.='<br>DBL : '.$bato->dbl;
}
if (!empty($bato->log)){
	$s.='<br>LOG : '.$bato->log;
}
$s.='</p>]]>
</description>
	<LookAt>
    	<longitude>'.$bato->longitude.'</longitude>
		<latitude>'.$bato->latitude.'</latitude>
        <altitude>'.$altitude.'</altitude>
		<range>100000</range>
        <heading>'.$bato->cog.'</heading>
        <tilt>85</tilt>
		<altitudeMode>relativeToGround</altitudeMode>
    </LookAt>
<styleUrl>#Balise_sailboat</styleUrl>
	<Point>
		<gx:drawOrder>1</gx:drawOrder>
		<coordinates>'.$bato->longitude.','.$bato->latitude.',0</coordinates>
	</Point>
</Placemark>
';
		}
		else{
		$gite=$bato->GiteVoilier();
		
		$t_parcours[]=new Coordonnees($bato->longitude, $bato->latitude);
		
		if ($bato->nom!=''){

				$s.='<Placemark>
<name>'.$bato->nom.'</name>
<description>
<![CDATA[<p>
';
if (!empty($bato->mmsi)){
    $s.=' MMSI: '.$bato->mmsi;
}
else if (!empty($bato->idsol)){
    $s.=' IdSol: '.$bato->idsol;
}
$s.='<br>'.$bato->date_enregistrement.'
<br>Lon: '.$bato->longitude.'
<br>Lat: '.$bato->latitude.'
<br>COG: '.$bato->cog;
if (!empty($bato->sog)){
    $s.='<br>SOG: '.$bato->sog;
}
if (!empty($bato->classement)){
	$s.='<br>Rank : '.$bato->classement;
}
if (!empty($bato->dtg)){
	$s.='<br>DTG : '.$bato->dtg;
}
if (!empty($bato->dbl)){
	$s.='<br>DBL : '.$bato->dbl;
}
if (!empty($bato->log)){
	$s.='<br>LOG : '.$bato->log;
}
$s.='</p>]]>
</description>
	<LookAt>
    	<longitude>'.$bato->longitude.'</longitude>
		<latitude>'.$bato->latitude.'</latitude>
        <altitude>'.$altitude.'</altitude>
		<range>100000</range>
        <heading>'.$bato->cog.'</heading>
        <tilt>85</tilt>
		<altitudeMode>relativeToGround</altitudeMode>
    </LookAt>
';
				$s.='
	<styleUrl>#Balise_sailboat</styleUrl>
	<MultiGeometry>
    	<Point>
            <extrude>1</extrude>
            <altitudeMode>relativeToGround</altitudeMode>
            <coordinates>'.$bato->longitude.','.$bato->latitude.',0</coordinates>
		</Point>
';
 				$s.='		<Model>
			<altitudeMode>relativeToGround</altitudeMode>
	    	<Location>
    			<longitude>'.$bato->longitude.'</longitude>
    			<latitude>'.$bato->latitude.'</latitude>
    			<altitude>'.$altitude.'</altitude>
	    	</Location>
    		<Orientation>
    			<heading>'.$bato->cog.'</heading>
				<roll>'.$gite.'</roll>
    		</Orientation>
	    	<Scale>
    			<x>'.$echelle.'</x>
        		<y>'.$echelle.'</y>
        		<z>'.$echelle_z.'</z>
	    	</Scale>
';
				// A VERIFIER CAR ICI J'IMPROVISE
				$fichier_dae=GetFichierModele(GetNomVoile($bato->voile));
				if ($fichier_dae!=''){
					// recopier le fichier modele
					
					if (recopier_modele_dae($dossier_3d, $fichier_dae, $bato->nom, GetNomVoile($bato->voile))){
						$s.='			<Link id="'.$bato->nom.'">
    			<href>'.$url_modeles.'/'.$bato->nom.'_'.GetNomVoile($bato->voile).'.dae</href>
    		</Link>
';
			
					}
				}
				$s.= GenereRessourceMapBateau_3D($dossier_3d, $url_serveur, $bato);
				$s.='
		</Model>
	</MultiGeometry>
</Placemark>
';

			// Trajectoire
			if (isset($afficher_trajectoire) && ($afficher_trajectoire==1)){
				$s.=GenereTrajectoireBateauKML($bato, $altitude);
			}
		}
	}
	}
	return $s;
}
// --------------------
function GenereMarquesParcoursEtDebutPositionsBateauxKML_3D($okmarques=true){
global $INDEX_COURSE;
global $LEG;
global $url_serveur;
global $groupe;
global $course;
global $t_groupe;
global $url_fichier_marque; // ='/sources/vor_styles_marques.kml';
	$s='';
	if ($okmarques){
	/*
		if ($course==$INDEX_COURSE){
			$s.=GenereMarquesParcours_boston_galway_rkn();
		}
		else{
			$s.=GenereMarquesParcours_vor($LEG);
		}
	*/
//Peut etre remplace par
		$s='
	<NetworkLink id="MarquesStyles">
		<name>Marques de parcours</name>
		<refreshVisibility>1</refreshVisibility>
		<flyToView>0</flyToView>
		<Link id="vgv2016">
			<href>';
	$s.=$url_serveur.$url_fichier_marque; // $url_fichier_marque='/sources/vor_styles_marques.kml';
	$s.='</href>
			<refreshMode>onChange</refreshMode>   
		</Link>
	</NetworkLink>
';

	}
	$s.= GenereStylesBalisesBateauxKML();
	$s.='	<Folder>
		<name>'.strtoupper($t_groupe[$groupe]).'_Position</name>
';
	return $s;
}

// -------------------------
function GenereEnQueueKML_3D(){
global $t_parcours;
	$s=GenereParcoursBateauxKML($t_parcours);
	$s.='</Folder>
	</Folder>
</Document>
</kml>
';
	return $s;
}

//------------------------
function genere_texture($chemin, $rouge, $vert, $bleu, $size=144){
// cree une image RVB
	if (file_exists($chemin.'/c_'.$rouge.'_'.$vert.'_'.$bleu.'.PNG')){
		return 'c_'.$rouge.'_'.$vert.'_'.$bleu.'.PNG';
	}
	else{
		// Gnrer les textures  la volee
		$image=imagecreatetruecolor($size, $size);
		$back = imagecolorallocate($image, $rouge, $vert, $bleu);
		imagefilledrectangle($image, 0, 0, $size - 1, $size - 1, $back);
		// Enregistrer l'image
		$fichier=$chemin.'/c_'.$rouge.'_'.$vert.'_'.$bleu.'.PNG';
		$ok=imagepng($image, $fichier);
		imagedestroy($image);
		if ($ok){
			return 'c_'.$rouge.'_'.$vert.'_'.$bleu.'.PNG';
		}
		else{
			return '';
		}
	}
}


//------------------------
function recopier_modele_dae($dossier_3d, $fichier_dae, $nom_bato, $voile){
// copie du modele sous le nom du bateau
global $dir_serveur;
global $extension_dae;
global $dossier_modeles;
	if (file_exists($dir_serveur.'/sources_3d/'.$dossier_modeles.'/'.$fichier_dae)){
		$contenu=file_get_contents($dir_serveur.'/sources_3d/'.$dossier_modeles.'/'.$fichier_dae);
		$f_name=$dir_serveur.'/'.$dossier_3d.'/'.$dossier_modeles.'/'.$nom_bato.'_'.$voile.$extension_dae;
		$fp = fopen($f_name, 'w');
		if ($fp){
			fwrite($fp, $contenu);
			fclose($fp);
		}
	}
	return $fp;
}



// -----------------------
function EnregistreKML_3D($dossier_3d,  $contenu,  $archive=false, $en=false){
// Deux fichiers sont crees : un fichier d'archive et un fichier courant (dit de cache) au contenu mmsientique.
// c'est ce fichier de cache (dont le nom est toujours mmsientique) qui est appel par le fichier rkn.kml lu par GoogleEarth
// Le dossier d'achive est zipp

global $dir_serveur;
global $fichier_kml_courant;
global $fichier_kml_cache;
global $extension_kml;
global $extension_kmz;
global $dossier_modeles;
global $dossier_textures;
$fichier_kml_cache_3d=$fichier_kml_cache.'3D';

	
	// Commencer par enregister le fichier KML
	$f_cache_name=$dir_serveur.'/'.$dossier_3d.'/'.$fichier_kml_cache_3d.$extension_kml;
	$fp_data = fopen($f_cache_name, 'w');
	if ($fp_data ){
		fwrite($fp_data, $contenu);
		fclose($fp_data);
	}

	if ($archive==true){
		// faire une copie zippee du  dossier $dossier_3d 
		// if (creer_fichier_zip($dir_serveur, $dossier_3d, $fichier_kml_cache_3d)){
			// if (creer_fichier_zip('', $dossier_3d, $fichier_kml_cache_3d)){
		$t_fichiers=array();
		$t_fichiers[0]=$dossier_3d.'/'.$fichier_kml_cache_3d.$extension_kml;
		$t_fichiers[1]=$dossier_3d.'/'.$dossier_modeles;
		$t_fichiers[2]=$dossier_3d.'/'.$dossier_textures;

		if (creer_fichier_zip($dossier_3d, $t_fichiers, $fichier_kml_cache_3d)){
			// puis le renommer .kmz
			$nom_fichier_kmz=renommer_fichier($fichier_kml_cache_3d, $extension_kmz);
			// DEBUG
			// echo "<br>DEBUG :: kml_3d.php :: 390 :: $nom_fichier_kmz\n";
			if ($nom_fichier_kmz!=''){
				// creer un fichier d'archive
				// le nom du fichier d'archive recoit une date+heure qui sera utilisee 
				// pour verifier si le delai depuis la gnration prcdente est suffisant
				$f_name_cache=$dir_serveur.'/'.$nom_fichier_kmz;
				$f_archive=$dir_serveur.'/'.nom_fichier($nom_fichier_kmz).date('YmdH').$extension_kmz;
				copy($f_name_cache, $f_archive);
				if ($en){
					echo '<br>The file <a href="'.$fichier_kml_cache_3d.$extension_kmz.'"><b>'.$fichier_kml_cache_3d.$extension_kmz.'</b></a> is updated.'."\n";
				}
				else{
					echo '<br>Le fichier <a href="'.$fichier_kml_cache_3d.$extension_kmz.'"><b>'.$fichier_kml_cache_3d.$extension_kmz.'</b></a> a &eacute;t&eacute; actualis&eacute;.'."\n";
				}
				// echo '<br>Le fichier d\'archive <a href="'.$f_name_cache.'"><b>'.$f_name_cache.'</b></a> a &eacute;t&eacute; actualis&eacute;.'."\n";
			}
		}
	}
	else{
		if ($en){
		echo '<br>The file <a href="'.$fichier_kml_cache_3d.$extension_kml.'"><b>'.$fichier_kml_cache_3d.$extension_kml.'</b></a> is updated.'."\n";

		}
		else{
		echo '<br>Le fichier <a href="'.$fichier_kml_cache_3d.$extension_kml.'"><b>'.$fichier_kml_cache_3d.$extension_kml.'</b></a> a &eacute;t&eacute; actualis&eacute;.'."\n";
		}
	}
}

// -----------------------
function ExisteKML_3D(){
// verifie si une generation a ete faite durant l'heure courante
global $dir_serveur;
global $dossier_3d;
global $fichier_kml_courant;
global $fichier_kml_cache;
global $extension_kml;
global $extension_kmz;
$fichier_kml_cache_3d=$fichier_kml_cache.'3D';

	$f_data_name=$dir_serveur.'/'.$fichier_kml_cache_3d.date('YmdH').$extension_kmz;
	// DEBUG
	// echo "<br>Fichier courant: $f_data_name\n";
	
	if (file_exists($f_data_name)){
		return $f_data_name;
	}
	else{
		return '';
	}
}

// --------------------
function GenereStylesBalisesBateauxKML(){
global $url_serveur;
	$s='
<Style id="Balise_sailboat">
<IconStyle>
<scale>0.4</scale>
<Icon>
<href>http://maps.google.com/mapfiles/kml/shapes/sailing.png</href>
</Icon>
</IconStyle>
</Style>

';

	return $s;
}


// --------------------
function GenereEnteteKML_3D($longitude, $latitude, $cog){
global $groupe; // groupe courant determine aussi le prefixe du fichier KML
global $t_groupe; // code du groupe
$cog_oppose=(($cog+180) % 360);

// <href>http://maps.google.com/mapfiles/kml/shapes/arrow.png</href>
	$s='<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://www.opengis.net/kml/2.2" xmlns:gx="http://www.google.com/kml/ext/2.2" xmlns:kml="http://www.opengis.net/kml/2.2" xmlns:atom="http://www.w3.org/2005/Atom">
<Document>
	<Style id="pmIcon">
    	<IconStyle id="">
        	<color>CC00FFFF</color>
        	<scale>0.5,0.5</scale>
        	<Icon>
';
	$s.='        	<href>http://maps.google.com/mapfiles/kml/pal4/icon21.png</href>'."\n";

	$s.='        	</Icon>
		    <hotSpot x="0.5"  y="0.5" xunits="fraction" yunits="fraction"/>    <!-- kml:vec2 -->
      	</IconStyle>
		<LineStyle>
			<wmmsith>1</wmmsith>
		</LineStyle>
    </Style>
<Folder>
	<name>'.strtoupper($t_groupe[$groupe]).'_3D</name>
	<open>1</open>
	<LookAt>
		<longitude>'.$longitude.'</longitude>
		<latitude>'.$latitude.'</latitude>
        <altitude>5000000</altitude>
		<range>100000</range>
        <heading>0</heading>
        <tilt>'.$cog_oppose.'</tilt>

		<range>100000</range>
        <heading>270</heading>
        <tilt>20</tilt>

	</LookAt>
';
return $s;
}


// --------------------
function GenereKML_3D($dossier_3d, $url_serveur){	
// gnere le fichier courant  charger dans Google Earth

global $dir_serveur;
global $fichier_kml_courant;
global $fichier_kml_cache;
global $extension_kml;
global $extension_kmz;
$fichier_kml_cache_3d=$fichier_kml_cache.'3D';

	$s='<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://www.opengis.net/kml/2.2">
  <Folder>
    <NetworkLink>
      <refreshVisibility>0</refreshVisibility>
      <flyToView>1</flyToView>
      <Link>
        <href>'.$url_serveur.'/'.$dossier_3d.'/'.$fichier_kml_cache_3d.$extension_kml.'</href>
        <refreshInterval>1800</refreshInterval>
        <viewRefreshMode>onRequest</viewRefreshMode>
      </Link>
    </NetworkLink>
  </Folder>
</kml>
';
	// enregistrer ce ficher
	$fp_data = fopen($fichier_kml_courant.$extension_kml, 'w');
	if ($fp_data ){
		fwrite($fp_data, $s);
		fclose($fp_data);
	}
}

?>